;
; test_soft_core.asm
;
; Created: 		23.09.2021 17:32:29
; Author : 		Steffen Hoerhold
; MPU    :		$partname$

.equ	F_CPU			= 16_000_000

;--- Konstanten --------------------------------------------------------

.equ    CYCLES_PER_MS   = ((F_CPU)/1000)
.equ    CYCLES_PER_US   = ((F_CPU)/1000000)

;*************************** wartet ca. 1ms *******************************
; Sub: Wartet ca. 1ms
; Parameter:	-
; Return:		-
; Scratch-Reg:	-
;***************************************************************************

.macro  delayms                    ; ldt 16Bit @1 nach @0 High und @0 Low
        ldi     r25,HIGH(@0)
        ldi     r24,LOW(@0)
		call	delay_ms
.endmacro

.macro  delayus                    ; ldt 16Bit @1 nach @0 High und @0 Low
        ldi     r25,HIGH(@0)
        ldi     r24,LOW(@0)
		call	delay_us
.endmacro


.org 0						rjmp	reset
reti	; 001
reti	; 002
reti	; 003
reti	; 004
reti	; 005
reti	; 006
reti	; 007
reti	; 008
reti	; 009
reti	; 010
reti	; 011
reti	; 012
reti	; 013
reti	; 014
reti	; 015
reti	; 016
reti	; 017
reti	; 018
reti	; 019
reti	; 020
reti	; 021
reti	; 022
reti	; 023
reti	; 024
reti	; 025
reti	; 026
reti	; 027
reti	; 028
reti	; 029
reti	; 030
reti	; 031
reti	; 032
reti	; 033
reti	; 034
reti	; 035
reti	; 036
reti	; 037
reti	; 038
reti	; 039
reti	; 040
reti	; 041
reti	; 042
.org 43

reset:
	ldi		r16,0b00000111
	out		DDRB,r16
loop:
	ldi		r16,0b00000100
	out		PORTB,r16
	rcall	delay_led
	ldi		r16,0b00000000
	out		PORTB,r16
	rcall	delay_led
	rjmp	loop




delay_led:
	ldi		r17,2
loop1a:
	ldi		r16,3
loop2a:
	dec		r16
	brne	loop2a
	dec		r17
	brne	loop1a
	ret

	ldi		r16,0b00000000
	out		PORTB,r16

	ldi		r18,10
loop1b:
	ldi		r17,255
loop2b:
	ldi		r16,255
loop3b:
	dec		r16
	brne	loop3b
	dec		r17
	brne	loop2b
	dec		r18
	brne	loop1b
	rjmp	loop


; Replace with your application code
start:
    inc r16
    rjmp start


//----------------------------------------------------------------------
//     DELAY's @16Mhz
//----------------------------------------------------------------------



delay_ms: // r24:r25
		rcall	wait1ms
		sbiw	r24,1
		brne	delay_ms
		ret

delay_us: // r24:r25
		rcall	wait1us
		sbiw	r24,1
		brne	delay_us
		ret

wait1ms:
		push	XH
		push	XL
		ldi		XH,high((CYCLES_PER_MS)/4)			; 4 Anzahl der Zyklen fr die Schleife
		ldi		XL,low((CYCLES_PER_MS)/4)
wait1msloop:
		sbiw	X,1
		brne	wait1msloop
		pop		XL
		pop		XH
		ret

waitXms:
		rcall	wait1ms
		dec		r16
		brne	waitXms
		ret

waitXus:
		rcall	wait1us
		dec		r16
		brne	waitXus
		ret

wait1us:		; @ 16Mhz
;		lpm		
		lpm		
		lpm		
		ret
